//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_color3  Silver
#property indicator_color4  LimeGreen
#property indicator_color5  LimeGreen
#property indicator_color6  PaleVioletRed
#property indicator_color7  PaleVioletRed
#property indicator_style1  STYLE_DOT
#property indicator_style2  STYLE_DOT
#property indicator_width3  2
#property indicator_width4  3
#property indicator_width5  3
#property indicator_width6  3
#property indicator_width7  3

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    SZOPeriod       = 14;
extern int    SZOLongPeriod   = 30;
extern int    SZOPrice        = PRICE_CLOSE;
extern double SZOPercent      = 95;
extern bool   Interpolate     = true;

//
//
//
//
//

double upz[];
double upzUa[];
double upzUb[];
double dnz[];
double dnzDa[];
double dnzDb[];
double szo[];
double breakout[];

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,upz);
   SetIndexBuffer(1,dnz);
   SetIndexBuffer(2,szo);
   SetIndexBuffer(3,upzUa);
   SetIndexBuffer(4,upzUb);
   SetIndexBuffer(5,dnzDa);
   SetIndexBuffer(6,dnzDb);
   SetIndexBuffer(7,breakout);

      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
               
      IndicatorShortName(timeFrameToString(timeFrame)+" Sentiment zone oscillator ("+SZOPeriod+","+SZOLongPeriod+")");
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double prices[];
int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
            int limit=MathMin(Bars-counted_bars,Bars-1);
            if (returnBars) { upz[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //


   if (calculateValue || timeFrame == Period())
   {
      if (ArraySize(prices)!=Bars) ArrayResize(prices,Bars);
      if (breakout[limit]== 1) CleanPoint(limit,upzUa,upzUb);
      if (breakout[limit]==-1) CleanPoint(limit,dnzDa,dnzDb);
      for(i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         prices[r] = iMA(NULL,0,1,0,MODE_SMA,SZOPrice,i);
            double useValue = 0;
               if (prices[r]>prices[r-1]) useValue =  1;
               if (prices[r]<prices[r-1]) useValue = -1;
            double result = 100.0*iTema(useValue,SZOPeriod,i);
      
            //
            //
            //
            //
            //
         
            szo[i] =  result/SZOPeriod;
               double hi = szo[ArrayMaximum(szo,SZOLongPeriod,i)];
               double lo = szo[ArrayMinimum(szo,SZOLongPeriod,i)];
               double rn = hi-lo;
            upz[i]   = lo+rn*SZOPercent/100.0;
            dnz[i]   = hi-rn*SZOPercent/100.0;
            upzUa[i] = EMPTY_VALUE;
            upzUb[i] = EMPTY_VALUE;
            dnzDa[i] = EMPTY_VALUE;
            dnzDa[i] = EMPTY_VALUE;
            breakout[i] = breakout[i+1];
               if (szo[i]>upz[i])                  breakout[i] =  1;
               if (szo[i]<dnz[i])                  breakout[i] = -1;
               if (szo[i]>dnz[i] && szo[i]<upz[i]) breakout[i] =  0;
               if (breakout[i]== 1) PlotPoint(i,upzUa,upzUb,szo);
               if (breakout[i]==-1) PlotPoint(i,dnzDa,dnzDb,szo);
      }       
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   if (breakout[limit]== 1) CleanPoint(limit,upzUa,upzUb);
   if (breakout[limit]==-1) CleanPoint(limit,dnzDa,dnzDb);
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         upz[i]      = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SZOPeriod,SZOLongPeriod,SZOPrice,SZOPercent,0,y);
         dnz[i]      = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SZOPeriod,SZOLongPeriod,SZOPrice,SZOPercent,1,y);
         szo[i]      = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SZOPeriod,SZOLongPeriod,SZOPrice,SZOPercent,2,y);
         breakout[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SZOPeriod,SZOLongPeriod,SZOPrice,SZOPercent,7,y);
         upzUa[i] = EMPTY_VALUE;
         upzUb[i] = EMPTY_VALUE;
         dnzDa[i] = EMPTY_VALUE;
         dnzDa[i] = EMPTY_VALUE;

         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

            datetime time = iTime(NULL,timeFrame,y);
               for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
               for(int k = 1; k < n; k++)
               {
                  upz[i+k] = upz[i] + (upz[i+n] - upz[i])*k/n;
                  dnz[i+k] = dnz[i] + (dnz[i+n] - dnz[i])*k/n;
                  szo[i+k] = szo[i] + (szo[i+n] - szo[i])*k/n;
               }
   }
   for (i=limit;i>=0;i--)
   {
      if (breakout[i]== 1) PlotPoint(i,upzUa,upzUb,szo);
      if (breakout[i]==-1) PlotPoint(i,dnzDa,dnzDb,szo);
   }      
   return(0);
         
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workTema[][3];
#define _ema1 0
#define _ema2 1
#define _ema3 2

double iTema(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workTema,0)!= Bars) ArrayResize(workTema,Bars); instanceNo*=3; r = Bars-r-1;

   //
   //
   //
   //
   //
      
   double alpha = 2.0 / (1.0+period);
          workTema[r][_ema1+instanceNo] = workTema[r-1][_ema1+instanceNo]+alpha*(price                        -workTema[r-1][_ema1+instanceNo]);
          workTema[r][_ema2+instanceNo] = workTema[r-1][_ema2+instanceNo]+alpha*(workTema[r][_ema1+instanceNo]-workTema[r-1][_ema2+instanceNo]);
          workTema[r][_ema3+instanceNo] = workTema[r-1][_ema3+instanceNo]+alpha*(workTema[r][_ema2+instanceNo]-workTema[r-1][_ema3+instanceNo]);
   return(workTema[r][_ema3+instanceNo]+3.0*(workTema[r][_ema1+instanceNo]-workTema[r][_ema2+instanceNo]));
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}